// This file was auto-generated by genbindings.py

#include <lemon/list_graph.h>
#include <lemon/smart_graph.h>
#include <lemon/static_graph.h>

#include <lemon/network_simplex.h>
#include <lemon/cost_scaling.h>
#include <lemon/capacity_scaling.h>
#include <lemon/cycle_canceling.h>

#include <pybind11/pybind11.h>
#include <pybind11/numpy.h>

namespace py = pybind11;

using namespace lemon;
using namespace std;

#if LEMONPY_BASE_SIZE == 64
#define INTEGER_TYPE long long int
#else
#define INTEGER_TYPE int
#endif


void list_digraph(py::module_ & m) {
  
  py::class_<ListDigraph> graph(m, "ListDigraph");
  
  graph
    .def(py::init<>())
    .def("addNode", &ListDigraph::addNode, "Add a new node to the digraph.")
    .def("addArc", &ListDigraph::addArc, "Add a new arc to the digraph.")
    .def("erase", py::overload_cast<ListDigraph::Node>(&ListDigraph::erase), "Erase a node from the digraph.")
    .def("erase", py::overload_cast<ListDigraph::Arc>(&ListDigraph::erase), "Erase an arc from the digraph.")
    .def("valid", py::overload_cast<ListDigraph::Node>(&ListDigraph::valid, py::const_), "Node validity check.")
    .def("valid", py::overload_cast<ListDigraph::Arc>(&ListDigraph::valid, py::const_), "Arc validity check.")
    .def("changeTarget", &ListDigraph::changeTarget, "Change the target node of an arc.")
    .def("changeSource", &ListDigraph::changeSource, "Change the source node of an arc.")
    .def("reverseArc", &ListDigraph::reverseArc, "Reverse the direction of an arc.")
    .def("contract", &ListDigraph::contract, "Contract two nodes.")
    .def("split", py::overload_cast<ListDigraph::Node, bool>(&ListDigraph::split), "Split a node.")
    .def("split", py::overload_cast<ListDigraph::Arc>(&ListDigraph::split), "Split an arc.")
    .def("clear", &ListDigraph::clear, "Clear the digraph.")
    .def("reserveNode", &ListDigraph::reserveNode, "Reserve memory for nodes.")
    .def("reserveArc", &ListDigraph::reserveArc, "Reserve memory for arcs.");
  
  
  graph
    .def("id", py::overload_cast<ListDigraph::Node>(&ListDigraph::id), "The ID of the node.")
    .def("id", py::overload_cast<ListDigraph::Arc>(&ListDigraph::id), "The ID of the arc.")
    .def("nodeFromId", &ListDigraph::nodeFromId, "The node with the given ID.")
    .def("arcFromId", &ListDigraph::arcFromId, "The arc with the given ID.")
    .def("oppositeNode", &ListDigraph::oppositeNode, "The opposite node on the arc.")
    .def("source", &ListDigraph::source, "The source node of the arc.")
    .def("target", &ListDigraph::target, "The target node of the arc.");
  
  
  py::class_<ListDigraph::Node>(graph, "Node");
  py::class_<ListDigraph::Arc>(graph, "Arc");
  
  
  py::class_<ListDigraph::NodeMap<INTEGER_TYPE>>(graph, "NodeMap")
    .def(py::init<const ListDigraph &>())
    .def("set", &ListDigraph::NodeMap<INTEGER_TYPE>::set)
    .def("__setitem__", &ListDigraph::NodeMap<INTEGER_TYPE>::set)
    .def("get", py::overload_cast<const ListDigraph::Node &>(&ListDigraph::NodeMap<INTEGER_TYPE>::operator[], py::const_))
    .def("__getitem__", py::overload_cast<const ListDigraph::Node &>(&ListDigraph::NodeMap<INTEGER_TYPE>::operator[], py::const_));
  
  
  py::class_<ListDigraph::ArcMap<INTEGER_TYPE>>(graph, "ArcMap")
    .def(py::init<const ListDigraph &>())
    .def("set", &ListDigraph::ArcMap<INTEGER_TYPE>::set)
    .def("__setitem__", &ListDigraph::ArcMap<INTEGER_TYPE>::set)
    .def("get", py::overload_cast<const ListDigraph::Arc &>(&ListDigraph::ArcMap<INTEGER_TYPE>::operator[], py::const_))
    .def("__getitem__", py::overload_cast<const ListDigraph::Arc &>(&ListDigraph::ArcMap<INTEGER_TYPE>::operator[], py::const_));
  
  
  py::class_<NetworkSimplex<ListDigraph, INTEGER_TYPE>> solver0(graph, "NetworkSimplex");
  solver0
    .def(py::init<const ListDigraph &>())
    // setup
    .def("lowerMap", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::lowerMap<ListDigraph::ArcMap<INTEGER_TYPE>>, "Set the lower bounds on the arcs.")
    .def("upperMap", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::upperMap<ListDigraph::ArcMap<INTEGER_TYPE>>, "Set the upper bounds (capacities) on the arcs.")
    .def("costMap", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::costMap<ListDigraph::ArcMap<INTEGER_TYPE>>, "Set the costs of the arcs.")
    .def("supplyMap", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::supplyMap<ListDigraph::NodeMap<INTEGER_TYPE>>, "Set the supply values of the nodes.")
    // running and resetting
    .def("run", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::run, "Run the algorithm.")
    .def("resetParams", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::resetParams, "Reset all the parameters that have been given before.")
    .def("reset", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::reset, "Reset the internal data structures and all the parameters that have been given before.")
    // query results
    .def("totalCost", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::totalCost<double>, "Return the total cost of the found flow.")
    .def("flow", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::flow, "Return the flow on the given arc.")
    .def("potential", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::potential, "Return the flow map (the primal solution).")
    .def("flowMap", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::flowMap<ListDigraph::ArcMap<INTEGER_TYPE>>, "Return the potential (dual value) of the given node.")
    .def("potentialMap", &NetworkSimplex<ListDigraph, INTEGER_TYPE>::potentialMap<ListDigraph::NodeMap<INTEGER_TYPE>>, "Return the potential map (the dual solution).");
      
  py::enum_<NetworkSimplex<ListDigraph, INTEGER_TYPE>::ProblemType>(solver0, "ProblemType")
    .value("INFEASIBLE", NetworkSimplex<ListDigraph, INTEGER_TYPE>::ProblemType::INFEASIBLE)
    .value("OPTIMAL", NetworkSimplex<ListDigraph, INTEGER_TYPE>::ProblemType::OPTIMAL)
    .value("UNBOUNDED", NetworkSimplex<ListDigraph, INTEGER_TYPE>::ProblemType::UNBOUNDED);
  
  py::enum_<NetworkSimplex<ListDigraph, INTEGER_TYPE>::PivotRule>(solver0, "PivotRule")
    .value("FIRST_ELIGIBLE", NetworkSimplex<ListDigraph, INTEGER_TYPE>::PivotRule::FIRST_ELIGIBLE)
    .value("BEST_ELIGIBLE", NetworkSimplex<ListDigraph, INTEGER_TYPE>::PivotRule::BEST_ELIGIBLE)
    .value("BLOCK_SEARCH", NetworkSimplex<ListDigraph, INTEGER_TYPE>::PivotRule::BLOCK_SEARCH)
    .value("CANDIDATE_LIST", NetworkSimplex<ListDigraph, INTEGER_TYPE>::PivotRule::CANDIDATE_LIST)
    .value("ALTERING_LIST", NetworkSimplex<ListDigraph, INTEGER_TYPE>::PivotRule::ALTERING_LIST);
  
  py::enum_<NetworkSimplex<ListDigraph, INTEGER_TYPE>::SupplyType> (solver0, "SupplyType")
    .value("GEQ", NetworkSimplex<ListDigraph, INTEGER_TYPE>::SupplyType::GEQ)
    .value("LEQ", NetworkSimplex<ListDigraph, INTEGER_TYPE>::SupplyType::LEQ);
  
  
  py::class_<CostScaling<ListDigraph, INTEGER_TYPE>> solver1(graph, "CostScaling");
  solver1
    .def(py::init<const ListDigraph &>())
    // setup
    .def("lowerMap", &CostScaling<ListDigraph, INTEGER_TYPE>::lowerMap<ListDigraph::ArcMap<INTEGER_TYPE>>, "Set the lower bounds on the arcs.")
    .def("upperMap", &CostScaling<ListDigraph, INTEGER_TYPE>::upperMap<ListDigraph::ArcMap<INTEGER_TYPE>>, "Set the upper bounds (capacities) on the arcs.")
    .def("costMap", &CostScaling<ListDigraph, INTEGER_TYPE>::costMap<ListDigraph::ArcMap<INTEGER_TYPE>>, "Set the costs of the arcs.")
    .def("supplyMap", &CostScaling<ListDigraph, INTEGER_TYPE>::supplyMap<ListDigraph::NodeMap<INTEGER_TYPE>>, "Set the supply values of the nodes.")
    // running and resetting
    .def("run", &CostScaling<ListDigraph, INTEGER_TYPE>::run, "Run the algorithm.")
    .def("resetParams", &CostScaling<ListDigraph, INTEGER_TYPE>::resetParams, "Reset all the parameters that have been given before.")
    .def("reset", &CostScaling<ListDigraph, INTEGER_TYPE>::reset, "Reset the internal data structures and all the parameters that have been given before.")
    // query results
    .def("totalCost", &CostScaling<ListDigraph, INTEGER_TYPE>::totalCost<double>, "Return the total cost of the found flow.")
    .def("flow", &CostScaling<ListDigraph, INTEGER_TYPE>::flow, "Return the flow on the given arc.")
    .def("potential", &CostScaling<ListDigraph, INTEGER_TYPE>::potential, "Return the flow map (the primal solution).")
    .def("flowMap", &CostScaling<ListDigraph, INTEGER_TYPE>::flowMap<ListDigraph::ArcMap<INTEGER_TYPE>>, "Return the potential (dual value) of the given node.")
    .def("potentialMap", &CostScaling<ListDigraph, INTEGER_TYPE>::potentialMap<ListDigraph::NodeMap<INTEGER_TYPE>>, "Return the potential map (the dual solution).");
  
  py::enum_<CostScaling<ListDigraph, INTEGER_TYPE>::ProblemType>(solver1, "ProblemType")
    .value("INFEASIBLE", CostScaling<ListDigraph, INTEGER_TYPE>::ProblemType::INFEASIBLE)
    .value("OPTIMAL", CostScaling<ListDigraph, INTEGER_TYPE>::ProblemType::OPTIMAL)
    .value("UNBOUNDED", CostScaling<ListDigraph, INTEGER_TYPE>::ProblemType::UNBOUNDED);
  
  py::enum_<CostScaling<ListDigraph, INTEGER_TYPE>::Method>(solver1, "Method")
    .value("PUSH", CostScaling<ListDigraph, INTEGER_TYPE>::Method::PUSH)
    .value("AUGMENT", CostScaling<ListDigraph, INTEGER_TYPE>::Method::AUGMENT)
    .value("PARTIAL_AUGMENT", CostScaling<ListDigraph, INTEGER_TYPE>::Method::PARTIAL_AUGMENT);
  
}
